// Forlix SoStats
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2009-2011 Dominik Friedrichs


public Event_PlayerSpawn(Handle:event,
                         const String:Event_type[],
                         bool:dontBroadcast)
{
  new client = GetClientOfUserId(GetEventInt(event, "userid"));

  if(!GetClientTeam(client))
  // not an actual spawn (just "entered the game")
    return;

  if(!p_spawned[client])
  // players first spawn since connect
  {
    p_spawned[client] = true;

    if(announcement_type == 1)
      PrintAnnouncementMsg(client);
  }

  return;
}


public Action:Event_PlayerChangeName(Handle:event,
                                     const String:name[],
                                     bool:dontBroadcast)
{
  new client = GetClientOfUserId(GetEventInt(event, "userid"));

  GetEventString(event, "newname", p_name[client], sizeof(p_name[]));
  MakeStringPrintable(p_name[client], sizeof(p_name[]), NAME_STR_EMPTY);

  WritePlayerToDatabase(h_statsdb, client, false);
  return(Plugin_Continue);
}


public Event_PlayerTeam(Handle:event,
                        const String:Event_type[],
                        bool:dontBroadcast)
{
  CreateTimer(0.0, PlayerTeam_Delayed);
  return;
}


public Action:PlayerTeam_Delayed(Handle:htimer)
{
  CheckTrackingAllowed();
  return(Plugin_Stop);
}


public Event_RoundStart(Handle:event,
                        const String:Event_type[],
                        bool:dontBroadcast)
{
  CheckTrackingAllowed(true);

  for(new client = 1; client <= MaxClients; client++)
    p_rankcmds[client] = 0;

  if(announcement_type == 0)
    PrintAnnouncementMsg(0);

  return;
}


public Event_RoundEnd(Handle:event,
                      const String:Event_type[],
                      bool:dontBroadcast)
{
  WriteAllPlayersToDatabase(h_statsdb, false);
  RefreshDBMaintainedData();

  return;
}
