// Forlix SoStats
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2009-2011 Dominik Friedrichs


public Action:HelpPanel(client, args)
{
  if(!client)
    return(Plugin_Continue);

  if(!p_init[client]
  || DeadTimeBlock(client))
    return(Plugin_Handled);

  // respond to plugin command
  decl String:buf[256];

  new Handle:pn = CreatePanel();
  SetGlobalTransTarget(client);

  Format(buf, sizeof(buf), "Forlix SoStats v%s\n ", PLUGIN_VERSION);
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "%t\n ", "PLUGIN_STATS", players_tracked, rk_lowest);
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "%t\n ", "HELPPANEL_TEXT");
  DrawPanelText(pn, buf);

  DrawPanelText(pn, "(c) 2009-2011 Forlix\nEmail: df@forlix.org\nWeb: http://forlix.org/\n ");

  new pn_keys = 0;

  if(p_fl_abs[client] & PLAYER_TRACKMSGS)
  {
    pn_keys |= (1<<9-1);
    Format(buf, sizeof(buf), "->9. %t", "DISABLE_TRACKMSGS");
    DrawPanelText(pn, buf);
  }
  else
  {
    pn_keys |= (1<<9-1);
    Format(buf, sizeof(buf), "->9. %t", "ENABLE_TRACKMSGS");
    DrawPanelText(pn, buf);
  }

  if(allow_player_stats_reset)
  {
    pn_keys |= (1<<5-1);
    Format(buf, sizeof(buf), "->5. %t", "RESET_STATS");
    DrawPanelText(pn, buf);
  }

  DrawPanelText(pn, " ");

  pn_keys |= (1<<10-1);
  Format(buf, sizeof(buf), "0. %t", "EXIT");
  DrawPanelText(pn, buf);

  SetPanelKeys(pn, pn_keys);

  SendPanelToClient(pn, client, HelpPanelReturn, PANEL_DISPLAYTIME);
  CloseHandle(pn);

  return(Plugin_Handled);
}


public HelpPanelReturn(Handle:panel,
                       MenuAction:action,
                       param1,
                       param2)
{
  if(action != MenuAction_Select
  || param2 == 10)
    return;

  new client = param1;
  SetGlobalTransTarget(client);

  switch(param2)
  {
    case 9:
    // toggle trackmsgs
    {
      p_fl_abs[client] ^= PLAYER_TRACKMSGS;

      if(p_fl_abs[client] & PLAYER_TRACKMSGS)
        PrintToChat(client, "%t", "TRACKMSGS_ENABLED");
      else
        PrintToChat(client, "%t", "TRACKMSGS_DISABLED");
    }

    case 5:
    // display reset stats question
    {
      new Handle:pn = CreatePanel();
      decl String:buf[256];

      Format(buf, sizeof(buf), "%t\n ", "RESET_STATS_QUESTION");
      DrawPanelText(pn, buf);

      Format(buf, sizeof(buf), "->1. %t", "RESET");
      DrawPanelText(pn, buf);

      Format(buf, sizeof(buf), "0. %t", "CANCEL");
      DrawPanelText(pn, buf);

      SetPanelKeys(pn, (1<<1-1)|(1<<10-1));

      SendPanelToClient(pn, client, StatsResetReturn, PANEL_DISPLAYTIME);
      CloseHandle(pn);
    }
  }

  EmitSoundToClient(client, MENU_CONFIRM_SOUND);
  return;
}


public StatsResetReturn(Handle:panel,
                        MenuAction:action,
                        param1,
                        param2)
{
  if(action != MenuAction_Select
  || param2 != 1)
    return;

  new client = param1;

  // recreate player entry
  DropPlayerFromDatabase(h_statsdb, client);
  CreatePlayerInDatabase(h_statsdb, client);

  PrintToChat(client, "%t", "PLAYER_STATS_RESET");
  EmitSoundToClient(client, MENU_CONFIRM_SOUND);

  return;
}
