// Forlix SoStats
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2009-2011 Dominik Friedrichs


Rank(client)
{
  if(!p_init[client]
  || DeadTimeBlock(client))
    return;

  if(max_rankcmds_per_round
  && p_rankcmds[client] >= max_rankcmds_per_round)
  {
    CreateTimer(0.0, RankLimitReached_Delayed, GetClientUserId(client));
    return;
  }

  p_rankcmds[client]++;
  decl String:query[SQL_QUERY_MAXLEN];

  Format(query, sizeof(query), SQL_PLAYER_RANK_READ, p_steamid[client]);
  SQL_TQuery(h_statsdb, SQL_OnPlayerRankRead, query, GetClientUserId(client), SQL_PLAYER_INTERACT_PRIORITY);

  return;
}


public Action:RankLimitReached_Delayed(Handle:htimer, any:userid)
{
  new client = GetClientOfUserId(userid);

  if(!client)
    return(Plugin_Stop);

  PrintToChat(client, "%t", "RANK_LIMIT_REACHED", max_rankcmds_per_round);
  return(Plugin_Stop);
}


public SQL_OnPlayerRankRead(Handle:owner,
                            Handle:hndl,
                            const String:error[],
                            any:userid)
{
  if(hndl == INVALID_HANDLE)
  {
    LogError("SQL_OnPlayerRankRead failure: %s", error);
    return;
  }

  if(!SQL_HasResultSet(hndl)
  || !SQL_FetchRow(hndl))
  {
    LogError("SQL_OnPlayerRankRead failure: No result");
    return;
  }

  new client = GetClientOfUserId(userid);

  if(!client)
    return;

  new rk = SQL_FetchInt(hndl, 0);
  new pt = SQL_FetchInt(hndl, 1);
  new Float:gm_ratio = SQL_FetchFloat(hndl, 2);
  new Float:sl_ratio = SQL_FetchFloat(hndl, 3);
  new Float:sf_ratio = SQL_FetchFloat(hndl, 4);

  if(rk)
  {
    if(!p_rk_onj[client])
      p_rk_onj[client] = rk;

    for(new i = 1; i <= MaxClients; i++)
    if(IsClientInGame(i))
      PrintToChat(i, "%t", "PLAYER_RANK",
                           p_name[client], rk, rk_lowest, pt, gm_ratio, sl_ratio, sf_ratio);
  }
  else
  {
    for(new i = 1; i <= MaxClients; i++)
    if(IsClientInGame(i))
      PrintToChat(i, "%t", "PLAYER_RANK_NOT_YET",
                           p_name[client], pt, gm_ratio, sl_ratio, sf_ratio);
  }

  return;
}
