// Forlix SoStats
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2009-2011 Dominik Friedrichs


Session(client)
{
  if(!p_init[client]
  || DeadTimeBlock(client))
    return;

  decl String:query[SQL_QUERY_MAXLEN];

  Format(query, sizeof(query), SQL_PLAYER_SESSION_READ, p_steamid[client]);
  SQL_TQuery(h_statsdb, SQL_OnPlayerSessionRead, query, GetClientUserId(client), SQL_PLAYER_INTERACT_PRIORITY);

  return;
}


public SQL_OnPlayerSessionRead(Handle:owner,
                               Handle:hndl,
                               const String:error[],
                               any:userid)
{
  if(hndl == INVALID_HANDLE)
  {
    LogError("SQL_OnPlayerSessionRead failure: %s", error);
    return;
  }

  if(!SQL_HasResultSet(hndl))
  {
    LogError("SQL_OnPlayerSessionRead failure: No result");
    return;
  }

  new client = GetClientOfUserId(userid);

  if(!client)
    return;

  new rk = 0;

  if(SQL_FetchRow(hndl))
    rk = SQL_FetchInt(hndl, 0);

  new Handle:pn = CreatePanel();
  SetGlobalTransTarget(client);

  decl String:buf[256];

  Format(buf, sizeof(buf), "Forlix SoStats                Session\n ");
  DrawPanelText(pn, buf);

  decl String:name[MAX_NAME_LENGTH];

  new len = strcopy(name, sizeof(name), p_name[client]);
  TruncateString(name, len, 20);
  Format(buf, sizeof(buf), "%t %s", "PLAYER", name);
  DrawPanelText(pn, buf);

  new pt_sess = p_pt_abs[client]-p_pt_onj[client];

  if(rk)
  {
    if(!p_rk_onj[client])
      p_rk_onj[client] = rk;

    new rk_sess = p_rk_onj[client]-rk;

    Format(buf, sizeof(buf), "%t %s%i   %t %s%i\n ",
                             "POINTS", pt_sess > 0? "+":"", pt_sess,
                             "RANK", rk_sess > 0? "+":"", rk_sess);
  }
  else
    Format(buf, sizeof(buf), "%t %s%i   %t - %t -\n ",
                             "POINTS", pt_sess > 0? "+":"", pt_sess,
                             "RANK", "NONE_YET");

  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "->1. %t", "GOALS");
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "  %t %u   %t %u",
                           "GOALS", SessionProp(client, GOALS),
                           "MISSES", SessionProp(client, MISSES));
  DrawPanelText(pn, buf);

  new Float:gm_ratio = float(SessionProp(client, GOALS))
                      /float(SessionProp(client, MISSES));
  Format(buf, sizeof(buf), "  - %t %.2f", "GM_RATIO", gm_ratio);
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "  %t %u   %t %u\n ",
                           "ASSISTS", SessionProp(client, ASSISTS),
                           "OWN_GOALS", SessionProp(client, OWN_GOALS));
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "->2. %t", "KEEPER");
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "  %t %u   %t %u",
                           "SAVES", SessionProp(client, KEEPER_SAVES),
                           "FAILS", SessionProp(client, KEEPER_FAILS));
  DrawPanelText(pn, buf);

  new Float:sf_ratio = float(SessionProp(client, KEEPER_SAVES))
                      /float(SessionProp(client, KEEPER_FAILS));
  Format(buf, sizeof(buf), "  - %t %.2f\n ", "SF_RATIO", sf_ratio);
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "->3. %t", "BALL");
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "  %t\n  - %t %u   - %t %u",
                           "PASSES",
                           "GROUND", SessionProp(client, GROUND_PASSES),
                           "AIR", SessionProp(client, AIR_PASSES));
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "  %t %u   %t %u",
                           "STEALS", SessionProp(client, STEALS),
                           "LOSSES", SessionProp(client, LOSSES));
  DrawPanelText(pn, buf);

  new Float:sl_ratio = float(SessionProp(client, STEALS))
                      /float(SessionProp(client, LOSSES));
  Format(buf, sizeof(buf), "  - %t %.2f\n ", "SL_RATIO", sl_ratio);
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "->4. %t", "ROUNDS");
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "  %t %u   %t %u\n ",
                           "WON", SessionProp(client, ROUNDS_WON),
                           "LOST", SessionProp(client, ROUNDS_LOST));
  DrawPanelText(pn, buf);

  decl String:str_ftime[32];
  FriendlyTime(TimeConnected(client), str_ftime, sizeof(str_ftime));

  Format(buf, sizeof(buf), "%t %s", "TIME_PLAYED", str_ftime);
  DrawPanelText(pn, buf);

  Format(buf, sizeof(buf), "Steam %s%s", STEAMID_PREFIX, p_steamid[client]);
  DrawPanelText(pn, buf);

  // respond to any key
  SetPanelKeys(pn, 0xFFFF);

  SendPanelToClient(pn, client, SessionReturn, PANEL_DISPLAYTIME);
  CloseHandle(pn);

  return;
}


public SessionReturn(Handle:panel,
                     MenuAction:action,
                     param1,
                     param2)
{
  return;
}


SessionProp(client, prop)
{
  return(p_props_abs[client][prop]-p_props_onj[client][prop]);
}
